#include <algorithm>
#include "rendersort.hpp"


////////////////////////////////////////////////////////////////////////////////

void
CRenderSort::AddObject(int base_x, int base_y, int offset_x, int offset_y, IMAGE image)
{
  Object object;
  object.base_x   = base_x;
  object.base_y   = base_y;
  object.offset_x = offset_x;
  object.offset_y = offset_y;
  object.image    = image;
  m_objects.push_back(object);
}

////////////////////////////////////////////////////////////////////////////////

void
CRenderSort::DrawObjects()
{
  // sort the object list
  std::sort(
    m_objects.begin(),
    m_objects.end(),
    CompareObjects
  );

  // draw images to screen
  for (int i = 0; i < m_objects.size(); i++) {
    Object& o = m_objects[i];
    BlitImage(o.image, o.base_x - o.offset_x, o.base_y - o.offset_y);
  }

  m_objects.clear();
}

////////////////////////////////////////////////////////////////////////////////

bool
CRenderSort::CompareObjects(const Object& a, const Object& b)
{
  return (a.base_y < b.base_y);
}

////////////////////////////////////////////////////////////////////////////////
