#ifndef __SMAP_HPP
#define __SMAP_HPP


#include <vector>
#include "video.h"
#include "../common/Map.hpp"
#include "../common/Layer.hpp"
#include "../common/Tileset.hpp"


class SMAP
{
public:
  SMAP();
  ~SMAP();

  bool Load(FILE* file);
  void InitDelayMap();
  void UpdateAnimations();

  IMAGE GetTileImage(int tile);

  sMap&     GetMap();
  sTileset& GetTileset();

private:
  void InitializeDelayMap();

private:
  sMap m_Map;
  std::vector<std::vector<int> > m_DelayMap;    // [layer][y * width + x]

  std::vector<IMAGE> m_Tiles;
};


////////////////////////////////////////////////////////////////////////////////

inline IMAGE
SMAP::GetTileImage(int tile)
{
  return m_Tiles[tile];
}

////////////////////////////////////////////////////////////////////////////////

inline sMap&
SMAP::GetMap()
{
  return m_Map;
}

////////////////////////////////////////////////////////////////////////////////

inline sTileset&
SMAP::GetTileset()
{
  return m_Map.GetTileset();
}

////////////////////////////////////////////////////////////////////////////////


#endif
